unit AJCsvDbFrm;
{ Tstringlist
    procedure NavOpen;
    procedure NavClose;
    procedure NavFirst;
    procedure NavPrev;
    procedure NavNext;
    procedure NavLast;
    procedure NavFind;
    procedure NavUpdate;
    procedure NavAppend;
    procedure NavDelete;
    procedure NavPack;
    procedure NavDesign;
    procedure NavCreate;
    procedure NavInsertField;
    procedure NavDeleteField;
    procedure NavRenameField;
    procedure NavResizeField;
    procedure NavExit;
    procedure NavAddRow;
    procedure NavDeleteRow;

function TjansDB3.FindRecord(fieldnr: integer; value: string): boolean;
function TjansDB3.NumRecs: integer; return number of records
NumFields "" fields
function TjansDB3.goRec(RecNr: integer): boolean;   NumRecs-1 is LAST RECORD
procedure TjansDB3.AppendRecord;
}
interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ImgList, GraphicEx, Printers,
  jansDB3Images, jansDB3Nav, jansDB3,
  Grids, ToolWin, StdCtrls, ExtCtrls;

type
  TGCsvDbForm = class(TForm)
    ToolBar1: TToolBar;
    DB3Table: TStringGrid;
    DB3: TjansDB3;
    DB3Nav: TjansDB3Nav;
    DB3img: TjansDB3Images;
    DB3ToolButton19: TToolButton;
    DB3ToolButton18: TToolButton;
    DB3ToolButton17: TToolButton;
    DB3ToolButton16: TToolButton;
    DB3ToolButton15: TToolButton;
    DB3ToolButton14: TToolButton;
    DB3ToolButton13: TToolButton;
    DB3ToolButton12: TToolButton;
    DB3ToolButton11: TToolButton;
    DB3ToolButton10: TToolButton;
    DB3ToolButton9: TToolButton;
    DB3ToolButton8: TToolButton;
    DB3ToolButton7: TToolButton;
    DB3ToolButton6: TToolButton;
    DB3ToolButton5: TToolButton;
    DB3ToolButton4: TToolButton;
    DB3ToolButton3: TToolButton;
    DB3ToolButton2: TToolButton;
    DB3ToolButton1: TToolButton;
    PopupMenu1: TPopupMenu;
    About1: TMenuItem;
    HelpDb: TMenuItem;
    Exit1: TMenuItem;
    Print1: TMenuItem;
    View1: TMenuItem;
    Panel1: TPanel;
    Settext1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    ListBox2: TListBox;
    N3: TMenuItem;
    PrintDb1: TMenuItem;
    PrintDbImage1: TMenuItem;
    PrintDbAddresses1: TMenuItem;
    RichEdit1: TRichEdit;
    SaveDBasCVS1: TMenuItem;
    SaveDialog1: TSaveDialog;
    PrintDbAddresses2: TMenuItem;
    FileintoDb1: TMenuItem;
    N4: TMenuItem;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure HelpDbClick(Sender: TObject);
    procedure About1Click(Sender: TObject);

    procedure DB3ToolButton1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Settext1Click(Sender: TObject);
    procedure FileintoDb1Click(Sender: TObject);
procedure DoLoad(FileName: String;var X,Y:Integer);
    procedure View1Click(Sender: TObject);
    procedure PrintDb1Click(Sender: TObject);
    procedure PrintDbImage1Click(Sender: TObject);
    procedure PrintDbAddresses1Click(Sender: TObject);
    procedure SaveDBasCVS1Click(Sender: TObject);
    procedure PrintDbAddresses2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GCsvDbForm: TGCsvDbForm;
  DoThisFile:String;
implementation

uses LoGlobals, PicView, {efGScreenPrint,} {Preprint, PreBPPre, }
  GBfrm;

{$R *.DFM}

{var
  DB3TableRow: Longint;}

procedure TGCsvDbForm.FormCreate(Sender: TObject);
begin
{  left := GListFormX;
  top := GListFormY;   }
end;
procedure TGCsvDbForm.FormShow(Sender: TObject);
begin
 { left := GCsvDbFormX;
  top := GCsvDbFormY; }
end;
procedure TGCsvDbForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TGCsvDbForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  {GCsvDbFormX := GCsvDbForm.left;
  GCsvDbFormY := GCsvDbForm.top;}
 If AlreadyGone then
  begin
  RichEdit1.Clear;
  ListBox2.Clear;
  If DB3.IsOpen then DB3.CloseTable;
    Action := caFree;
  end else Action:=caHide;
end;



procedure TGCsvDbForm.HelpDbClick(Sender: TObject);
begin
  Application.HelpContext(10000);
end;

procedure TGCsvDbForm.About1Click(Sender: TObject);
begin
 { PicAboutBox.Init(10);
  PicAboutBox.ShowModal;   }
end;

procedure TGCsvDbForm.DB3ToolButton1Click(Sender: TObject);
begin
  DB3Nav.NavEvents(sender);
  If DB3.IsOpen then
     GCsvDbForm.Caption:= DB3.FileName+' : '+Inttostr(DB3.NumRecs);
end;

{Takes info from List and Makes data into Record}
procedure TGCsvDbForm.FileintoDb1Click(Sender: TObject);
var
   S:String;
   f: file of Byte;
   X,Y:Integer;
   size : Longint;
begin
If DB3.IsOpen then
begin
 If (DB3.NumFields >5) then
 begin
  If ListBox2.Items.Count>0 then
  begin
   S:=ListBox2.Items.Strings[0];
   If FileExists(S) then
   begin
   DB3.AppendRecord;
   DB3Table.Cells[1,1]:=ExtractFilePath(S);
   DB3Table.Cells[1,2]:=ExtractFileName(S);
   DoLoad(S,X,Y);
   DB3Table.Cells[1,3]:=IntToStr(X);
   DB3Table.Cells[1,4]:=IntToStr(Y);
     AssignFile(f, S);
     Reset(f);
     size := FileSize(f);
   DB3Table.Cells[1,5]:=IntToStr(size);
   DB3Table.Cells[1,6]:=Copy(ExtractFileExt(S),2,3);
   DB3.UpDateRecord;
   end;
   ListBox2.Items.Delete(0);
  end;
 end;
end;
end;

{procedure TGCsvDbForm.Button1Click(Sender: TObject);
begin
If DB3.IsOpen then
begin
 If (DB3.NumFields >5) then
 begin
   DB3.AppendRecord;
   DB3Table.Cells[1,7]:='1234567';
   DB3Table.Cells[1,8]:='987654321';
   DB3Table.Cells[1,9]:='Mr.';
   DB3Table.Cells[1,10]:='1234567890';
   DB3Table.Cells[1,11]:='12345';
   DB3Table.Cells[1,12]:='123456789012345';

   DB3Table.Cells[1,13]:='12345';
   DB3Table.Cells[1,14]:='1234567890123456789012345';
   DB3Table.Cells[1,15]:='12345';

   DB3Table.Cells[1,16]:='123456789012345';
   DB3Table.Cells[1,17]:='12.';
   DB3Table.Cells[1,18]:='1234567890';
   DB3Table.Cells[1,19]:='123.';
   DB3.UpDateRecord;
end;end;
end;}

procedure TGCsvDbForm.DoLoad(FileName: String;var X,Y:Integer);
var
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
  Target:TBitmap;
begin
      // determine true file type from content rather than extension
      GraphicClass := FileFormatList.GraphicFromContent(FileName);
      if GraphicClass = nil then Image1.Picture.LoadFromFile(FileName)
      else
      begin
        // GraphicFromContent always returns TGraphicExGraphicClass
        Graphic := GraphicClass.Create;
        Graphic.LoadFromFile(FileName);
        Image1.Picture.Graphic := Graphic;
      end;
        if (not(Image1.Picture.Graphic is TBitmap)) then
        begin
          Target := TBitmap.Create;
          Target.PixelFormat := pf24Bit;
          Target.Width := Image1.Picture.Width;
          Target.Height := Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, Image1.Picture.Graphic);
          Image1.Picture.Graphic := Target;
          Target.Free;
        end;
        Image1.Picture.Bitmap.PixelFormat := pf24bit;
        X:=Image1.Picture.Width;
        Y:=Image1.Picture.Height;
end;

procedure TGCsvDbForm.Settext1Click(Sender: TObject);
var
  I : Integer;
  S:String;
begin
  If DB3.IsOpen then
  begin
  with DB3Table do
    begin
    S:='';
    ListBox2.Clear;
      for I := 1 to 2 do
        begin
          S:= S+Cells[1,I];
        end;
    ListBox2.Items.Strings[0]:=S;
    end;
  end;
end;

procedure TGCsvDbForm.View1Click(Sender: TObject);
var DoThisFile:String;
begin
  If ListBox2.Items.Count>0 then
  begin
    DoThisFile:=ListBox2.Items.Strings[0];
    with PicViewBitmap do
    begin
      ViewFileName :=DoThisFile;
      DoLoad(ViewFileName);
      FocusedListBox:= nil;
      Show;
    end;
  DoThisFile:='';
end;
end;


procedure TGCsvDbForm.Print1Click(Sender: TObject);
begin
 { If ListBox2.Items.Count>0 then
  begin
    DoThisFile:=ListBox2.Items.Strings[0];
    If FileExists(DoThisFile) then
    begin
    with PicViewBitmap do
    begin
      ViewFileName :=DoThisFile;
      DoLoad(ViewFileName);
      FocusedListBox:= nil;
      Show;
    end;
  PrePrintForm:=TPrePrintForm.Create(Application);
  try
    PrePrintForm.SetupForm(DoThisFile,1);
    PicViewBitmap.Image1.Picture.Graphic:=nil;
    PicViewBitmap.Close;
    PrePrintForm.ShowModal;
  finally
    PrePrintForm.Release;
  end;
    end else Showmessage('File '+DoThisFile+' not there');
  DoThisFile:='';
  end;  }
end;


procedure TGCsvDbForm.SaveDBasCVS1Click(Sender: TObject);
var
  I,II, J,JJ : Integer;
  S:String;
begin
  If DB3.IsOpen then
  begin
  RichEdit1.Clear;
  RichEdit1.PlainText:=True;
  with DB3Table do
  begin
    JJ:=DB3.NumRecs;
    II:=DB3.NumFields;
    DB3.goFirst;
    for J:= 1 to JJ  do
    begin
      S:='';
      DB3Table.cols[1]:= DB3.GetValues;
      for I := 1 to II  do
        begin
          S:= S+Cells[1,I]+',';
        end;
      S[Length(S)]:=#13;{change last , }
      S:=S+#10;   {add CR to every line}
      RichEdit1.Lines.Add(S);
      DB3.gonext;
    end;
  end;
   SaveDialog1.FileName:= ChangeFileExt(DB3.FileName,'.txt');
   SaveDialog1.InitialDir:=ImagePath;
  if SaveDialog1.Execute then
        RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);
    RichEdit1.PlainText:=False;
end;
end;


procedure TGCsvDbForm.PrintDb1Click(Sender: TObject);
var
  I,II, J,JJ : Integer;
  S:String;
begin
  If DB3.IsOpen then
  begin
  RichEdit1.Clear;
  RichEdit1.PlainText:=True;
  with DB3Table do
  begin
    JJ:=DB3.NumRecs;
    II:=DB3.NumFields;
    DB3.goFirst;
    for J:= 1 to JJ  do
    begin
      S:='';
      DB3Table.cols[1]:= DB3.GetValues;
      for I := 1 to II  do
        begin
          S:= S+Cells[1,I]+',';
        end;
        SetLength(S,Length(S)-1);
      RichEdit1.Lines.Add(S);
      DB3.gonext;
    end;
  end;
  RichEdit1.Print( DB3.FileName);
  RichEdit1.PlainText:=False;
end;
end;


procedure TGCsvDbForm.PrintDbImage1Click(Sender: TObject);
var
  I, J,JJ : Integer;
  S:String;
begin
  If DB3.IsOpen then
  begin
  ResultFileList.Clear;
  with DB3Table do
  begin
    JJ:=DB3.NumRecs;
    DB3.goFirst;
    for J:= 1 to JJ  do
    begin
      S:='';
      DB3Table.cols[1]:= DB3.GetValues;
      for I := 1 to 2  do
        begin
          S:= S+Cells[1,I];
        end;
      If FileExists(S) then ResultFileList.Add(S);
      DB3.gonext;
    end;
end;
 { PrintForm.ShowModal;}
   GBForm.BrowseList;
   GBForm.Show;
end;
end;


procedure TGCsvDbForm.PrintDbAddresses1Click(Sender: TObject);
var
  i, II, J,JJ : Integer;
  S2,S3,S4,S:String;
  TempFont:TFont;
begin
  If DB3.IsOpen then
  begin
    RichEdit1.Clear;
    TempFont:=RichEdit1.Font;
    RichEdit1.Font:=Panel1.Font;
  with DB3Table do
  begin
    JJ:=DB3.NumRecs;
    II:=DB3.NumFields;
    If II < 16 then exit;
    DB3.goFirst;
    DB3Table.cols[1]:= DB3.GetValues;
    for J:= 1 to (JJ div 3)  do
    begin  {Make 3 columns 4 rows Tall !}
      S2:='';S3:='';S4:='';S:='';
      {Set length then Add spacer}
      S:= Cells[1,7]+' '+Cells[1,8];
      If Length(S)<31 then  For i:=1 to 31-Length(S) do s:=s+' '
      else SetLength(S,31);
      If Length(S)<34 then  For i:=1 to 34-Length(S) do s:=s+' ';
      S2:= Cells[1,9]+' '+Cells[1,10]+' '+Cells[1,11]+' '+Cells[1,12];
      If Length(S2)<31 then  For i:=1 to 31-Length(S2) do s2:=s2+' '
      else SetLength(S2,31);
      If Length(S2)<34 then  For i:=1 to 34-Length(S2) do s2:=s2+' ';
      S3:= Cells[1,13]+' '+Cells[1,14]+' '+Cells[1,15];
      If Length(S3)<31 then  For i:=1 to 31-Length(S3) do s3:=s3+' '
      else SetLength(S3,31);
      If Length(S3)<34 then  For i:=1 to 34-Length(S3) do s3:=s3+' ';
      S4:= Cells[1,16]+' '+Cells[1,17]+' '+Cells[1,18]+' '+Cells[1,19];
      If Length(S4)<31 then  For i:=1 to 31-Length(S4) do s4:=s4+' '
      else SetLength(S4,31);
      If Length(S4)<34 then  For i:=1 to 34-Length(S4) do s4:=s4+' ';
      DB3.gonext;
      DB3Table.cols[1]:= DB3.GetValues;
{Second of 3}      {Set length then Add spacer}
      S:= S+Cells[1,7]+' '+Cells[1,8];
      If Length(S)<64 then  For i:=1 to 64-Length(S) do s:=s+' '
      else SetLength(S,64);
      If Length(S)<72 then  For i:=1 to 72-Length(S) do s:=s+' ';
      S2:= S2+Cells[1,9]+' '+Cells[1,10]+' '+Cells[1,11]+' '+Cells[1,12];
      If Length(S2)<64 then  For i:=1 to 64-Length(S2) do s2:=s2+' '
      else SetLength(S2,64);
      If Length(S2)<72 then  For i:=1 to 72-Length(S2) do s2:=s2+' ';
      S3:= S3+Cells[1,13]+' '+Cells[1,14]+' '+Cells[1,15];
      If Length(S3)<64 then  For i:=1 to 64-Length(S3) do s3:=s3+' '
      else SetLength(S3,64);
      If Length(S3)<72 then  For i:=1 to 72-Length(S3) do s3:=s3+' ';
      S4:= S4+Cells[1,16]+' '+Cells[1,17]+' '+Cells[1,18]+' '+Cells[1,19];
      If Length(S4)<64 then  For i:=1 to 64-Length(S4) do s4:=s4+' '
      else SetLength(S4,64);
      If Length(S4)<72 then  For i:=1 to 72-Length(S4) do s4:=s4+' ';
      DB3.gonext;
      DB3Table.cols[1]:= DB3.GetValues;
{3 of 3}          {Clip to max length}
      S:= S+Cells[1,7]+' '+Cells[1,8];
      If Length(S)<102 then  For i:=1 to 102-Length(S) do s:=s+' '
      else SetLength(S,102);
      S2:= S2+Cells[1,9]+' '+Cells[1,10]+' '+Cells[1,11]+' '+Cells[1,12];
      If Length(S2)<102 then  For i:=1 to 102-Length(S2) do s2:=s2+' '
      else SetLength(S2,102);
      S3:= S3+Cells[1,13]+' '+Cells[1,14]+' '+Cells[1,15];
      If Length(S3)<102 then  For i:=1 to 102-Length(S3) do s3:=s3+' '
      else SetLength(S3,102);
      S4:= S4+Cells[1,16]+' '+Cells[1,17]+' '+Cells[1,18]+' '+Cells[1,19];
      If Length(S4)<102 then  For i:=1 to 102-Length(S4) do s4:=s4+' '
      else SetLength(S4,102);
      DB3.gonext;
      DB3Table.cols[1]:= DB3.GetValues;
{All done}
      RichEdit1.Lines.Add('');
      RichEdit1.Lines.Add('');
      RichEdit1.Lines.Add(S);
      RichEdit1.Lines.Add(S2);
      RichEdit1.Lines.Add(S3);
      RichEdit1.Lines.Add(S4);
      If (not((J / 10)=0))then RichEdit1.Lines.Add(' ');
      If (not((J / 10)=0))then RichEdit1.Lines.Add(' ');
    end;
  end;
  RichEdit1.Print('Address Labels');
  S2:='';S3:='';S4:='';S:='';
  RichEdit1.Clear;
  RichEdit1.Font:=TempFont;
end;
end;

                      {Preview Print}
procedure TGCsvDbForm.PrintDbAddresses2Click(Sender: TObject);
{var
  i,II, J,JJ : Integer;
  S2,S3,S4,S:String;  }
begin
(*  If DB3.IsOpen then
  begin
    JJ:=DB3.NumRecs;
    II:=DB3.NumFields;
    If II < 16 then exit;
  bzpForm:=TbzpForm.Create(Application);
  try
    bzpForm.ZRichEdit.Clear;
  with DB3Table do
  begin
    DB3.goFirst;
    DB3Table.cols[1]:= DB3.GetValues;
    for J:= 1 to (JJ div 3)  do
    begin  {Make 3 columns 4 rows Tall !}
      S2:='';S3:='';S4:='';S:='';
      {Set length then Add spacer}
      S:= Cells[1,7]+' '+Cells[1,8];
      If Length(S)<31 then  For i:=1 to 31-Length(S) do s:=s+' '
      else SetLength(S,31);
      If Length(S)<34 then  For i:=1 to 34-Length(S) do s:=s+' ';
      S2:= Cells[1,9]+' '+Cells[1,10]+' '+Cells[1,11]+' '+Cells[1,12];
      If Length(S2)<31 then  For i:=1 to 31-Length(S2) do s2:=s2+' '
      else SetLength(S2,31);
      If Length(S2)<34 then  For i:=1 to 34-Length(S2) do s2:=s2+' ';
      S3:= Cells[1,13]+' '+Cells[1,14]+' '+Cells[1,15];
      If Length(S3)<31 then  For i:=1 to 31-Length(S3) do s3:=s3+' '
      else SetLength(S3,31);
      If Length(S3)<34 then  For i:=1 to 34-Length(S3) do s3:=s3+' ';
      S4:= Cells[1,16]+' '+Cells[1,17]+' '+Cells[1,18]+' '+Cells[1,19];
      If Length(S4)<31 then  For i:=1 to 31-Length(S4) do s4:=s4+' '
      else SetLength(S4,31);
      If Length(S4)<34 then  For i:=1 to 34-Length(S4) do s4:=s4+' ';
      DB3.gonext;
      DB3Table.cols[1]:= DB3.GetValues;
{Second of 3}      {Set length then Add spacer}
      S:= S+Cells[1,7]+' '+Cells[1,8];
      If Length(S)<64 then  For i:=1 to 64-Length(S) do s:=s+' '
      else SetLength(S,64);
      If Length(S)<72 then  For i:=1 to 72-Length(S) do s:=s+' ';
      S2:= S2+Cells[1,9]+' '+Cells[1,10]+' '+Cells[1,11]+' '+Cells[1,12];
      If Length(S2)<64 then  For i:=1 to 64-Length(S2) do s2:=s2+' '
      else SetLength(S2,64);
      If Length(S2)<72 then  For i:=1 to 72-Length(S2) do s2:=s2+' ';
      S3:= S3+Cells[1,13]+' '+Cells[1,14]+' '+Cells[1,15];
      If Length(S3)<64 then  For i:=1 to 64-Length(S3) do s3:=s3+' '
      else SetLength(S3,64);
      If Length(S3)<72 then  For i:=1 to 72-Length(S3) do s3:=s3+' ';
      S4:= S4+Cells[1,16]+' '+Cells[1,17]+' '+Cells[1,18]+' '+Cells[1,19];
      If Length(S4)<64 then  For i:=1 to 64-Length(S4) do s4:=s4+' '
      else SetLength(S4,64);
      If Length(S4)<72 then  For i:=1 to 72-Length(S4) do s4:=s4+' ';
      DB3.gonext;
      DB3Table.cols[1]:= DB3.GetValues;
{3 of 3}          {Clip to max length}
      S:= S+Cells[1,7]+' '+Cells[1,8];
      If Length(S)<102 then  For i:=1 to 102-Length(S) do s:=s+' '
      else SetLength(S,102);
      S2:= S2+Cells[1,9]+' '+Cells[1,10]+' '+Cells[1,11]+' '+Cells[1,12];
      If Length(S2)<102 then  For i:=1 to 102-Length(S2) do s2:=s2+' '
      else SetLength(S2,102);
      S3:= S3+Cells[1,13]+' '+Cells[1,14]+' '+Cells[1,15];
      If Length(S3)<102 then  For i:=1 to 102-Length(S3) do s3:=s3+' '
      else SetLength(S3,102);
      S4:= S4+Cells[1,16]+' '+Cells[1,17]+' '+Cells[1,18]+' '+Cells[1,19];
      If Length(S4)<102 then  For i:=1 to 102-Length(S4) do s4:=s4+' '
      else SetLength(S4,102);
      DB3.gonext;
      DB3Table.cols[1]:= DB3.GetValues;
{All done}
      bzpForm.ZRichEdit.Lines.Add(' ');
      bzpForm.ZRichEdit.Lines.Add(' ');
      bzpForm.ZRichEdit.Lines.Add(S);
      bzpForm.ZRichEdit.Lines.Add(S2);
      bzpForm.ZRichEdit.Lines.Add(S3);
      bzpForm.ZRichEdit.Lines.Add(S4);
If (not((J / 10)=0))then bzpForm.ZRichEdit.Lines.Add(' ');
If (not((J / 10)=0))then bzpForm.ZRichEdit.Lines.Add(' ');
    end;
  end;
    bzpForm.ShowModal;
  finally
    bzpForm.Release;
    S2:='';S3:='';S4:='';S:='';
  end;
end;     *)
end;
{Print ALL records as Address Labels with an image at left}
{Print 1 Address Label with Image on EVERY label on 1 page}

end.
